import { LogBase, Logger } from '@pnpm/logger';
export declare const progressLogger: Logger<ProgressMessage>;
export interface LoggedPkg {
    rawSpec: string;
    name?: string;
    dependentId?: string;
}
export declare type ProgressMessage = {
    pkgId: string;
    pkg: LoggedPkg;
    status: 'resolved';
} | {
    pkg: LoggedPkg;
    status: 'error';
} | {
    pkgId: string;
    status: 'fetching_started';
    size: number | null;
    attempt: number;
} | {
    pkgId: string;
    status: 'fetching_progress';
    downloaded: number;
};
export declare type ProgressLog = {
    name: 'pnpm:progress';
} & LogBase & ProgressMessage;
export declare type Log = ProgressLog;
